Index: uspace/srv/net/tcp/rqueue.c
===================================================================
--- uspace/srv/net/tcp/rqueue.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/rqueue.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,8 +38,9 @@
 #include <errno.h>
 #include <io/log.h>
+#include <stdbool.h>
 #include <stdlib.h>
 #include <fibril.h>
+#include <fibril_synch.h>
 #include "conn.h"
-#include "pdu.h"
 #include "rqueue.h"
 #include "segment.h"
@@ -47,59 +48,32 @@
 #include "ucall.h"
 
-/** Transcode bounced segments.
- *
- * If defined, segments bounced via the internal debugging loopback will
- * be encoded to a PDU and the decoded. Otherwise they will be bounced back
- * directly without passing the encoder-decoder.
- */
-#define BOUNCE_TRANSCODE
-
 static prodcons_t rqueue;
+static bool fibril_active;
+static fibril_mutex_t lock;
+static fibril_condvar_t cv;
+static tcp_rqueue_cb_t *rqueue_cb;
 
 /** Initialize segment receive queue. */
-void tcp_rqueue_init(void)
+void tcp_rqueue_init(tcp_rqueue_cb_t *rcb)
 {
 	prodcons_initialize(&rqueue);
+	fibril_mutex_initialize(&lock);
+	fibril_condvar_initialize(&cv);
+	fibril_active = false;
+	rqueue_cb = rcb;
 }
 
-/** Bounce segment directy into receive queue without constructing the PDU.
- *
- * This is for testing purposes only.
- *
- * @param sp	Endpoint pair, oriented for transmission
- * @param seg	Segment
- */
-void tcp_rqueue_bounce_seg(inet_ep2_t *epp, tcp_segment_t *seg)
+/** Finalize segment receive queue. */
+void tcp_rqueue_fini(void)
 {
-	inet_ep2_t rident;
+	inet_ep2_t epp;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_rqueue_bounce_seg()");
+	inet_ep2_init(&epp);
+	tcp_rqueue_insert_seg(&epp, NULL);
 
-#ifdef BOUNCE_TRANSCODE
-	tcp_pdu_t *pdu;
-	tcp_segment_t *dseg;
-
-	if (tcp_pdu_encode(epp, seg, &pdu) != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Not enough memory. Segment dropped.");
-		return;
-	}
-
-	if (tcp_pdu_decode(pdu, &rident, &dseg) != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Not enough memory. Segment dropped.");
-		return;
-	}
-
-	tcp_pdu_delete(pdu);
-
-	/** Insert decoded segment into rqueue */
-	tcp_rqueue_insert_seg(&rident, dseg);
-	tcp_segment_delete(seg);
-#else
-	/* Reverse the identification */
-	tcp_ep2_flipped(epp, &rident);
-
-	/* Insert segment back into rqueue */
-	tcp_rqueue_insert_seg(&rident, seg);
-#endif
+	fibril_mutex_lock(&lock);
+	while (fibril_active)
+		fibril_condvar_wait(&cv, &lock);
+	fibril_mutex_unlock(&lock);
 }
 
@@ -107,12 +81,14 @@
  *
  * @param epp	Endpoint pair, oriented for reception
- * @param seg	Segment
+ * @param seg	Segment (ownership transferred to rqueue)
  */
 void tcp_rqueue_insert_seg(inet_ep2_t *epp, tcp_segment_t *seg)
 {
 	tcp_rqueue_entry_t *rqe;
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_rqueue_insert_seg()");
 
-	tcp_segment_dump(seg);
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "tcp_rqueue_insert_seg()");
+
+	if (seg != NULL)
+		tcp_segment_dump(seg);
 
 	rqe = calloc(1, sizeof(tcp_rqueue_entry_t));
@@ -140,9 +116,21 @@
 		rqe = list_get_instance(link, tcp_rqueue_entry_t, link);
 
-		tcp_as_segment_arrived(&rqe->epp, rqe->seg);
+		if (rqe->seg == NULL) {
+			free(rqe);
+			break;
+		}
+
+		rqueue_cb->seg_received(&rqe->epp, rqe->seg);
 		free(rqe);
 	}
 
-	/* Not reached */
+	log_msg(LOG_DEFAULT, LVL_DEBUG2, "tcp_rqueue_fibril() exiting");
+
+	/* Finished */
+	fibril_mutex_lock(&lock);
+	fibril_active = false;
+	fibril_mutex_unlock(&lock);
+	fibril_condvar_broadcast(&cv);
+
 	return 0;
 }
@@ -162,4 +150,5 @@
 
 	fibril_add_ready(fid);
+	fibril_active = true;
 }
 
Index: uspace/srv/net/tcp/rqueue.h
===================================================================
--- uspace/srv/net/tcp/rqueue.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/rqueue.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,9 +39,8 @@
 #include "tcp_type.h"
 
-extern void tcp_rqueue_init(void);
-extern void tcp_rqueue_bounce_seg(inet_ep2_t *, tcp_segment_t *);
+extern void tcp_rqueue_init(tcp_rqueue_cb_t *);
+extern void tcp_rqueue_fibril_start(void);
+extern void tcp_rqueue_fini(void);
 extern void tcp_rqueue_insert_seg(inet_ep2_t *, tcp_segment_t *);
-extern void tcp_rqueue_handler(void *);
-extern void tcp_rqueue_fibril_start(void);
 
 
Index: uspace/srv/net/tcp/segment.c
===================================================================
--- uspace/srv/net/tcp/segment.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/segment.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,5 +43,5 @@
 
 /** Alocate new segment structure. */
-tcp_segment_t *tcp_segment_new(void)
+static tcp_segment_t *tcp_segment_new(void)
 {
 	return calloc(1, sizeof(tcp_segment_t));
Index: uspace/srv/net/tcp/segment.h
===================================================================
--- uspace/srv/net/tcp/segment.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/segment.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,5 +40,4 @@
 #include "tcp_type.h"
 
-extern tcp_segment_t *tcp_segment_new(void);
 extern void tcp_segment_delete(tcp_segment_t *);
 extern tcp_segment_t *tcp_segment_dup(tcp_segment_t *);
Index: uspace/srv/net/tcp/seq_no.c
===================================================================
--- uspace/srv/net/tcp/seq_no.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/seq_no.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -134,5 +134,12 @@
 }
 
-/** Determine whether segment is fully acked */
+/** Determine whether segment is fully acked.
+ *
+ * @param conn Connection
+ * @param seg  Segment
+ * @param ack  Last received ACK (i.e. SND.UNA)
+ *
+ * @return @c true if segment is fully acked, @c false otherwise
+ */
 bool seq_no_segment_acked(tcp_conn_t *conn, tcp_segment_t *seg, uint32_t ack)
 {
@@ -141,5 +148,9 @@
 }
 
-/** Determine whether initial SYN is acked */
+/** Determine whether initial SYN is acked.
+ *
+ * @param conn Connection
+ * @return @c true if initial SYN is acked, @c false otherwise
+ */
 bool seq_no_syn_acked(tcp_conn_t *conn)
 {
@@ -147,14 +158,30 @@
 }
 
-/** Determine whether segment overlaps the receive window */
+/** Determine whether segment overlaps the receive window.
+ *
+ * @param conn Connection
+ * @param seg  Segment
+ * @return @c true if segment overlaps the receive window, @c false otherwise
+ */
 bool seq_no_segment_acceptable(tcp_conn_t *conn, tcp_segment_t *seg)
 {
 	bool b_in, e_in;
-
+	bool wb_in, we_in;
+
+	/* Beginning of segment is inside window */
 	b_in = seq_no_le_lt(conn->rcv_nxt, seg->seq, conn->rcv_nxt
 	    + conn->rcv_wnd);
 
+	/* End of segment is inside window */
 	e_in = seq_no_le_lt(conn->rcv_nxt, seg->seq + seg->len - 1,
 	    conn->rcv_nxt + conn->rcv_wnd);
+
+	/* Beginning of window is inside segment */
+	wb_in = seq_no_le_lt(seg->seq, conn->rcv_nxt,
+	    seg->seq + seg->len);
+
+	/* End of window is inside segment */
+	we_in = seq_no_le_lt(seg->seq, conn->rcv_nxt + conn->rcv_wnd - 1,
+	    seg->seq + seg->len);
 
 	if (seg->len == 0 && conn->rcv_wnd == 0) {
@@ -165,9 +192,13 @@
 		return false;
 	} else {
-		return b_in || e_in;
-	}
-}
-
-/** Determine size that control bits occupy in sequence space. */
+		return b_in || e_in || wb_in || we_in;
+	}
+}
+
+/** Determine size that control bits occupy in sequence space.
+ *
+ * @param ctrl Control bits combination
+ * @return Number of sequence space units occupied
+ */
 uint32_t seq_no_control_len(tcp_control_t ctrl)
 {
@@ -183,5 +214,11 @@
 }
 
-/** Calculate the amount of trim needed to fit segment in receive window. */
+/** Calculate the amount of trim needed to fit segment in receive window.
+ *
+ * @param conn  Connection
+ * @param seg   Segment
+ * @param left  Place to store number of units to trim at the beginning
+ * @param right Place to store number of units to trim at the end
+ */
 void seq_no_seg_trim_calc(tcp_conn_t *conn, tcp_segment_t *seg,
     uint32_t *left, uint32_t *right)
Index: uspace/srv/net/tcp/service.c
===================================================================
--- uspace/srv/net/tcp/service.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/service.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -705,4 +705,7 @@
 			log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_recv_impl() - EAGAIN");
 			return EAGAIN;
+		case TCP_ECLOSING:
+			*nrecv = 0;
+			return EOK;
 		default:
 			log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_conn_recv_impl() - trc=%d", rc);
Index: uspace/srv/net/tcp/tcp.c
===================================================================
--- uspace/srv/net/tcp/tcp.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/tcp.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,141 +36,22 @@
 
 #include <async.h>
-#include <bitops.h>
-#include <byteorder.h>
 #include <errno.h>
-#include <inet/inet.h>
 #include <io/log.h>
 #include <stdio.h>
-#include <stdlib.h>
 #include <task.h>
 
 #include "conn.h"
+#include "inet.h"
 #include "ncsim.h"
-#include "pdu.h"
 #include "rqueue.h"
 #include "service.h"
-#include "std.h"
-#include "tcp.h"
 #include "test.h"
+#include "ucall.h"
 
 #define NAME       "tcp"
 
-static int tcp_inet_ev_recv(inet_dgram_t *dgram);
-static void tcp_received_pdu(tcp_pdu_t *pdu);
-
-static inet_ev_ops_t tcp_inet_ev_ops = {
-	.recv = tcp_inet_ev_recv
+static tcp_rqueue_cb_t tcp_rqueue_cb = {
+	.seg_received = tcp_as_segment_arrived
 };
-
-/** Received datagram callback */
-static int tcp_inet_ev_recv(inet_dgram_t *dgram)
-{
-	uint8_t *pdu_raw;
-	size_t pdu_raw_size;
-
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_inet_ev_recv()");
-
-	pdu_raw = dgram->data;
-	pdu_raw_size = dgram->size;
-
-	/* Split into header and payload. */
-
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_inet_ev_recv() - split header/payload");
-
-	tcp_pdu_t *pdu;
-	size_t hdr_size;
-	tcp_header_t *hdr;
-	uint32_t data_offset;
-
-	if (pdu_raw_size < sizeof(tcp_header_t)) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "pdu_raw_size = %zu < sizeof(tcp_header_t) = %zu",
-		    pdu_raw_size, sizeof(tcp_header_t));
-		return EINVAL;
-	}
-
-	hdr = (tcp_header_t *)pdu_raw;
-	data_offset = BIT_RANGE_EXTRACT(uint32_t, DF_DATA_OFFSET_h, DF_DATA_OFFSET_l,
-	    uint16_t_be2host(hdr->doff_flags));
-
-	hdr_size = sizeof(uint32_t) * data_offset;
-
-	if (pdu_raw_size < hdr_size) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "pdu_raw_size = %zu < hdr_size = %zu",
-		    pdu_raw_size, hdr_size);
-		return EINVAL;
-	}
-
-	if (hdr_size < sizeof(tcp_header_t)) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "hdr_size = %zu < sizeof(tcp_header_t) = %zu",
-		    hdr_size, sizeof(tcp_header_t));		return EINVAL;
-	}
-
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "pdu_raw_size=%zu, hdr_size=%zu",
-	    pdu_raw_size, hdr_size);
-	pdu = tcp_pdu_create(pdu_raw, hdr_size, pdu_raw + hdr_size,
-	    pdu_raw_size - hdr_size);
-	if (pdu == NULL) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed creating PDU. Dropped.");
-		return ENOMEM;
-	}
-
-	pdu->src = dgram->src;
-	pdu->dest = dgram->dest;
-
-	tcp_received_pdu(pdu);
-	tcp_pdu_delete(pdu);
-
-	return EOK;
-}
-
-/** Transmit PDU over network layer. */
-void tcp_transmit_pdu(tcp_pdu_t *pdu)
-{
-	int rc;
-	uint8_t *pdu_raw;
-	size_t pdu_raw_size;
-	inet_dgram_t dgram;
-
-	pdu_raw_size = pdu->header_size + pdu->text_size;
-	pdu_raw = malloc(pdu_raw_size);
-	if (pdu_raw == NULL) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed to transmit PDU. Out of memory.");
-		return;
-	}
-
-	memcpy(pdu_raw, pdu->header, pdu->header_size);
-	memcpy(pdu_raw + pdu->header_size, pdu->text,
-	    pdu->text_size);
-
-	dgram.iplink = 0;
-	dgram.src = pdu->src;
-	dgram.dest = pdu->dest;
-	dgram.tos = 0;
-	dgram.data = pdu_raw;
-	dgram.size = pdu_raw_size;
-
-	rc = inet_send(&dgram, INET_TTL_MAX, 0);
-	if (rc != EOK)
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed to transmit PDU.");
-
-	free(pdu_raw);
-}
-
-/** Process received PDU. */
-static void tcp_received_pdu(tcp_pdu_t *pdu)
-{
-	tcp_segment_t *dseg;
-	inet_ep2_t rident;
-
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_received_pdu()");
-
-	if (tcp_pdu_decode(pdu, &rident, &dseg) != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Not enough memory. PDU dropped.");
-		return;
-	}
-
-	/* Insert decoded segment into rqueue */
-	tcp_rqueue_insert_seg(&rident, dseg);
-}
 
 static int tcp_init(void)
@@ -187,5 +68,5 @@
 	}
 
-	tcp_rqueue_init();
+	tcp_rqueue_init(&tcp_rqueue_cb);
 	tcp_rqueue_fibril_start();
 
@@ -195,9 +76,7 @@
 	if (0) tcp_test();
 
-	rc = inet_init(IP_PROTO_TCP, &tcp_inet_ev_ops);
-	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed connecting to internet service.");
+	rc = tcp_inet_init();
+	if (rc != EOK)
 		return ENOENT;
-	}
 
 	rc = tcp_service_init();
Index: uspace/srv/net/tcp/tcp_type.h
===================================================================
--- uspace/srv/net/tcp/tcp_type.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/tcp_type.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -126,13 +126,4 @@
 } tcp_iqueue_t;
 
-/** Retransmission queue */
-typedef struct {
-	struct tcp_conn *conn;
-	list_t list;
-
-	/** Retransmission timer */
-	fibril_timer_t *timer;
-} tcp_tqueue_t;
-
 /** Active or passive connection */
 typedef enum {
@@ -156,4 +147,83 @@
 	void (*recv_data)(tcp_conn_t *, void *);
 } tcp_cb_t;
+
+/** Data returned by Status user call */
+typedef struct {
+	/** Connection state */
+	tcp_cstate_t cstate;
+} tcp_conn_status_t;
+
+typedef struct {
+	/** SYN, FIN */
+	tcp_control_t ctrl;
+
+	/** Segment sequence number */
+	uint32_t seq;
+	/** Segment acknowledgement number */
+	uint32_t ack;
+	/** Segment length in sequence space */
+	uint32_t len;
+	/** Segment window */
+	uint32_t wnd;
+	/** Segment urgent pointer */
+	uint32_t up;
+
+	/** Segment data, may be moved when trimming segment */
+	void *data;
+	/** Segment data, original pointer used to free data */
+	void *dfptr;
+} tcp_segment_t;
+
+/** Receive queue entry */
+typedef struct {
+	link_t link;
+	inet_ep2_t epp;
+	tcp_segment_t *seg;
+} tcp_rqueue_entry_t;
+
+/** Receive queue callbacks */
+typedef struct {
+	/** Segment received */
+	void (*seg_received)(inet_ep2_t *, tcp_segment_t *);
+} tcp_rqueue_cb_t;
+
+/** NCSim queue entry */
+typedef struct {
+	link_t link;
+	suseconds_t delay;
+	inet_ep2_t epp;
+	tcp_segment_t *seg;
+} tcp_squeue_entry_t;
+
+/** Incoming queue entry */
+typedef struct {
+	link_t link;
+	tcp_segment_t *seg;
+} tcp_iqueue_entry_t;
+
+/** Retransmission queue entry */
+typedef struct {
+	link_t link;
+	tcp_conn_t *conn;
+	tcp_segment_t *seg;
+} tcp_tqueue_entry_t;
+
+/** Retransmission queue callbacks */
+typedef struct {
+	/** Segment received */
+	void (*transmit_seg)(inet_ep2_t *, tcp_segment_t *);
+} tcp_tqueue_cb_t;
+
+/** Retransmission queue */
+typedef struct {
+	struct tcp_conn *conn;
+	list_t list;
+
+	/** Retransmission timer */
+	fibril_timer_t *timer;
+
+	/** Callbacks */
+	tcp_tqueue_cb_t *cb;
+} tcp_tqueue_t;
 
 /** Connection */
@@ -169,4 +239,6 @@
 	/** Connection identification (local and remote endpoint) */
 	inet_ep2_t ident;
+	/** Connection is in association map */
+	bool mapped;
 
 	/** Active or passive connection */
@@ -246,59 +318,4 @@
 };
 
-/** Data returned by Status user call */
-typedef struct {
-	/** Connection state */
-	tcp_cstate_t cstate;
-} tcp_conn_status_t;
-
-typedef struct {
-	/** SYN, FIN */
-	tcp_control_t ctrl;
-
-	/** Segment sequence number */
-	uint32_t seq;
-	/** Segment acknowledgement number */
-	uint32_t ack;
-	/** Segment length in sequence space */
-	uint32_t len;
-	/** Segment window */
-	uint32_t wnd;
-	/** Segment urgent pointer */
-	uint32_t up;
-
-	/** Segment data, may be moved when trimming segment */
-	void *data;
-	/** Segment data, original pointer used to free data */
-	void *dfptr;
-} tcp_segment_t;
-
-/** Receive queue entry */
-typedef struct {
-	link_t link;
-	inet_ep2_t epp;
-	tcp_segment_t *seg;
-} tcp_rqueue_entry_t;
-
-/** NCSim queue entry */
-typedef struct {
-	link_t link;
-	suseconds_t delay;
-	inet_ep2_t epp;
-	tcp_segment_t *seg;
-} tcp_squeue_entry_t;
-
-/** Incoming queue entry */
-typedef struct {
-	link_t link;
-	tcp_segment_t *seg;
-} tcp_iqueue_entry_t;
-
-/** Retransmission queue entry */
-typedef struct {
-	link_t link;
-	tcp_conn_t *conn;
-	tcp_segment_t *seg;
-} tcp_tqueue_entry_t;
-
 /** Continuation of processing.
  *
@@ -354,5 +371,5 @@
 /** TCP client */
 typedef struct tcp_client {
-	/** Client callbac session */
+	/** Client callback session */
 	async_sess_t *sess;
 	/** Client's connections */
@@ -362,4 +379,14 @@
 } tcp_client_t;
 
+/** Internal loopback type */
+typedef enum {
+	/** No loopback */
+	tcp_lb_none,
+	/** Segment loopback */
+	tcp_lb_segment,
+	/** PDU loopback */
+	tcp_lb_pdu
+} tcp_lb_t;
+
 #endif
 
Index: uspace/srv/net/tcp/test/conn.c
===================================================================
--- uspace/srv/net/tcp/test/conn.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/srv/net/tcp/test/conn.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,247 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <inet/endpoint.h>
+#include <io/log.h>
+#include <pcut/pcut.h>
+
+#include "../conn.h"
+#include "../rqueue.h"
+#include "../ucall.h"
+
+PCUT_INIT
+
+PCUT_TEST_SUITE(conn);
+
+static tcp_rqueue_cb_t test_rqueue_cb = {
+	.seg_received = tcp_as_segment_arrived
+};
+
+PCUT_TEST_BEFORE
+{
+	int rc;
+
+	/* We will be calling functions that perform logging */
+	rc = log_init("test-tcp");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = tcp_conns_init();
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tcp_rqueue_init(&test_rqueue_cb);
+	tcp_rqueue_fibril_start();
+
+	/* Enable internal loopback */
+	tcp_conn_lb = tcp_lb_segment;
+}
+
+PCUT_TEST_AFTER
+{
+	tcp_rqueue_fini();
+	tcp_conns_fini();
+}
+
+/** Test creating and deleting connection */
+PCUT_TEST(new_delete)
+{
+	tcp_conn_t *conn;
+	inet_ep2_t epp;
+
+	inet_ep2_init(&epp);
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	tcp_conn_lock(conn);
+	tcp_conn_reset(conn);
+	tcp_conn_unlock(conn);
+	tcp_conn_delete(conn);
+}
+
+/** Test adding, finding and deleting a connection */
+PCUT_TEST(add_find_delete)
+{
+	tcp_conn_t *conn, *cfound;
+	inet_ep2_t epp;
+	int rc;
+
+	inet_ep2_init(&epp);
+
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	rc = tcp_conn_add(conn);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Find the connection */
+	cfound = tcp_conn_find_ref(&conn->ident);
+	PCUT_ASSERT_EQUALS(conn, cfound);
+	tcp_conn_delref(cfound);
+
+	/* We should have been assigned a port address, should not match */
+	cfound = tcp_conn_find_ref(&epp);
+	PCUT_ASSERT_EQUALS(NULL, cfound);
+
+	tcp_conn_lock(conn);
+	tcp_conn_reset(conn);
+	tcp_conn_unlock(conn);
+	tcp_conn_delete(conn);
+}
+
+/** Test trying to connect to endpoint that sends RST back */
+PCUT_TEST(connect_rst)
+{
+	tcp_conn_t *conn;
+	inet_ep2_t epp;
+	int rc;
+
+	inet_ep2_init(&epp);
+	inet_addr(&epp.local.addr, 127, 0, 0, 1);
+	inet_addr(&epp.remote.addr, 127, 0, 0, 1);
+	epp.remote.port = inet_port_user_lo;
+
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	rc = tcp_conn_add(conn);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(st_listen, conn->cstate);
+
+	tcp_conn_lock(conn);
+	tcp_conn_sync(conn);
+	PCUT_ASSERT_INT_EQUALS(st_syn_sent, conn->cstate);
+
+	while (conn->cstate == st_syn_sent)
+                fibril_condvar_wait(&conn->cstate_cv, &conn->lock);
+
+	PCUT_ASSERT_INT_EQUALS(st_closed, conn->cstate);
+
+	tcp_conn_unlock(conn);
+	tcp_conn_delete(conn);
+}
+
+/** Test establishing a connection */
+PCUT_TEST(conn_establish)
+{
+	tcp_conn_t *cconn, *sconn;
+	inet_ep2_t cepp, sepp;
+	int rc;
+
+	/* Client EPP */
+	inet_ep2_init(&cepp);
+	inet_addr(&cepp.local.addr, 127, 0, 0, 1);
+	inet_addr(&cepp.remote.addr, 127, 0, 0, 1);
+	cepp.remote.port = inet_port_user_lo;
+
+	/* Server EPP */
+	inet_ep2_init(&sepp);
+	inet_addr(&sepp.local.addr, 127, 0, 0, 1);
+	sepp.local.port = inet_port_user_lo;
+
+	/* Client side of the connection */
+	cconn = tcp_conn_new(&cepp);
+	PCUT_ASSERT_NOT_NULL(cconn);
+
+	rc = tcp_conn_add(cconn);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(st_listen, cconn->cstate);
+	PCUT_ASSERT_FALSE(tcp_conn_got_syn(cconn));
+
+	/* Server side of the connection */
+	sconn = tcp_conn_new(&sepp);
+	PCUT_ASSERT_NOT_NULL(sconn);
+
+	rc = tcp_conn_add(sconn);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_INT_EQUALS(st_listen, sconn->cstate);
+	PCUT_ASSERT_FALSE(tcp_conn_got_syn(sconn));
+
+	/* Start establishing the connection */
+
+	tcp_conn_lock(cconn);
+	tcp_conn_sync(cconn);
+	PCUT_ASSERT_INT_EQUALS(st_syn_sent, cconn->cstate);
+	PCUT_ASSERT_FALSE(tcp_conn_got_syn(cconn));
+
+	/* Wait for client-side state to transition */
+	while (cconn->cstate == st_syn_sent)
+                fibril_condvar_wait(&cconn->cstate_cv, &cconn->lock);
+
+	PCUT_ASSERT_INT_EQUALS(st_established, cconn->cstate);
+	PCUT_ASSERT_TRUE(tcp_conn_got_syn(cconn));
+	tcp_conn_unlock(cconn);
+
+	/* Wait for server-side state to transition */
+	tcp_conn_lock(sconn);
+	while (sconn->cstate == st_listen || sconn->cstate == st_syn_received)
+                fibril_condvar_wait(&sconn->cstate_cv, &sconn->lock);
+
+	PCUT_ASSERT_INT_EQUALS(st_established, sconn->cstate);
+	PCUT_ASSERT_TRUE(tcp_conn_got_syn(sconn));
+
+	/* Verify counters */
+	PCUT_ASSERT_EQUALS(cconn->iss + 1, cconn->snd_nxt);
+	PCUT_ASSERT_EQUALS(cconn->iss + 1, cconn->snd_una);
+	PCUT_ASSERT_EQUALS(sconn->iss + 1, sconn->snd_nxt);
+	PCUT_ASSERT_EQUALS(sconn->iss + 1, sconn->snd_una);
+
+	tcp_conn_unlock(sconn);
+
+	tcp_conn_lock(cconn);
+	tcp_conn_reset(cconn);
+	tcp_conn_unlock(cconn);
+	tcp_conn_delete(cconn);
+
+	tcp_conn_lock(sconn);
+	tcp_conn_reset(sconn);
+	tcp_conn_unlock(sconn);
+	tcp_conn_delete(sconn);
+}
+
+PCUT_TEST(ep2_flipped)
+{
+	inet_ep2_t a, fa;
+
+	inet_addr(&a.local.addr, 1, 2, 3, 4);
+	a.local.port = 1234;
+	inet_addr(&a.remote.addr, 5, 6, 7, 8);
+	a.remote.port = 5678;
+
+	tcp_ep2_flipped(&a, &fa);
+
+	PCUT_ASSERT_INT_EQUALS(a.local.port, fa.remote.port);
+	PCUT_ASSERT_INT_EQUALS(a.remote.port, fa.local.port);
+
+	PCUT_ASSERT_TRUE(inet_addr_compare(&a.local.addr, &fa.remote.addr));
+	PCUT_ASSERT_TRUE(inet_addr_compare(&a.remote.addr, &fa.local.addr));
+}
+
+PCUT_EXPORT(conn);
Index: uspace/srv/net/tcp/test/iqueue.c
===================================================================
--- uspace/srv/net/tcp/test/iqueue.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/srv/net/tcp/test/iqueue.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,179 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <inet/endpoint.h>
+#include <pcut/pcut.h>
+
+#include "../conn.h"
+#include "../iqueue.h"
+#include "../segment.h"
+
+PCUT_INIT
+
+PCUT_TEST_SUITE(iqueue);
+
+/** Test empty queue */
+PCUT_TEST(empty_queue)
+{
+	tcp_conn_t *conn;
+	tcp_iqueue_t iqueue;
+	inet_ep2_t epp;
+	tcp_segment_t *rseg;
+	int rc;
+
+	inet_ep2_init(&epp);
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	conn->rcv_nxt = 10;
+	conn->rcv_wnd = 20;
+
+	tcp_iqueue_init(&iqueue, conn);
+	rc = tcp_iqueue_get_ready_seg(&iqueue, &rseg);
+	PCUT_ASSERT_ERRNO_VAL(ENOENT, rc);
+
+	tcp_conn_delete(conn);
+}
+
+/** Test iqeue with one segment */
+PCUT_TEST(one_segment)
+{
+	tcp_conn_t *conn;
+	tcp_iqueue_t iqueue;
+	inet_ep2_t epp;
+	tcp_segment_t *rseg;
+	tcp_segment_t *seg;
+	void *data;
+	size_t dsize;
+	int rc;
+
+	inet_ep2_init(&epp);
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	conn->rcv_nxt = 10;
+	conn->rcv_wnd = 20;
+
+	dsize = 15;
+	data = calloc(dsize, 1);
+	PCUT_ASSERT_NOT_NULL(data);
+
+	seg = tcp_segment_make_data(0, data, dsize);
+	PCUT_ASSERT_NOT_NULL(seg);
+
+	tcp_iqueue_init(&iqueue, conn);
+	rc = tcp_iqueue_get_ready_seg(&iqueue, &rseg);
+	PCUT_ASSERT_ERRNO_VAL(ENOENT, rc);
+
+	seg->seq = 10;
+	tcp_iqueue_insert_seg(&iqueue, seg);
+	rc = tcp_iqueue_get_ready_seg(&iqueue, &rseg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	seg->seq = 15;
+	tcp_iqueue_insert_seg(&iqueue, seg);
+	rc = tcp_iqueue_get_ready_seg(&iqueue, &rseg);
+	PCUT_ASSERT_ERRNO_VAL(ENOENT, rc);
+	tcp_iqueue_remove_seg(&iqueue, seg);
+
+	tcp_segment_delete(seg);
+	free(data);
+	tcp_conn_delete(conn);
+}
+
+/** Test iqeue with two segments */
+PCUT_TEST(two_segments)
+{
+	tcp_conn_t *conn;
+	tcp_iqueue_t iqueue;
+	inet_ep2_t epp;
+	tcp_segment_t *rseg;
+	tcp_segment_t *seg1, *seg2;
+	void *data;
+	size_t dsize;
+	int rc;
+
+	inet_ep2_init(&epp);
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	conn->rcv_nxt = 10;
+	conn->rcv_wnd = 20;
+
+	dsize = 15;
+	data = calloc(dsize, 1);
+	PCUT_ASSERT_NOT_NULL(data);
+
+	seg1 = tcp_segment_make_data(0, data, dsize);
+	PCUT_ASSERT_NOT_NULL(seg1);
+	seg2 = tcp_segment_make_data(0, data, dsize);
+	PCUT_ASSERT_NOT_NULL(seg2);
+
+	tcp_iqueue_init(&iqueue, conn);
+	rc = tcp_iqueue_get_ready_seg(&iqueue, &rseg);
+	PCUT_ASSERT_ERRNO_VAL(ENOENT, rc);
+
+	/* Test reception in ascending order */
+	seg1->seq = 5;
+	tcp_iqueue_insert_seg(&iqueue, seg1);
+	seg2->seq = 10;
+	tcp_iqueue_insert_seg(&iqueue, seg2);
+
+	rc = tcp_iqueue_get_ready_seg(&iqueue, &rseg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_TRUE(rseg == seg1);
+
+	rc = tcp_iqueue_get_ready_seg(&iqueue, &rseg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_TRUE(rseg == seg2);
+
+	/* Test reception in descending order */
+	seg1->seq = 10;
+	tcp_iqueue_insert_seg(&iqueue, seg1);
+	seg2->seq = 5;
+	tcp_iqueue_insert_seg(&iqueue, seg2);
+
+	rc = tcp_iqueue_get_ready_seg(&iqueue, &rseg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS(seg2, rseg);
+
+	rc = tcp_iqueue_get_ready_seg(&iqueue, &rseg);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS(seg1, rseg);
+
+	rc = tcp_iqueue_get_ready_seg(&iqueue, &rseg);
+	PCUT_ASSERT_ERRNO_VAL(ENOENT, rc);
+
+	tcp_segment_delete(seg1);
+	tcp_segment_delete(seg2);
+	free(data);
+	tcp_conn_delete(conn);
+}
+
+
+PCUT_EXPORT(iqueue);
Index: uspace/srv/net/tcp/test/main.c
===================================================================
--- uspace/srv/net/tcp/test/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/srv/net/tcp/test/main.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2017 Jiri Svobda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <mem.h>
+#include <pcut/pcut.h>
+
+#include "main.h"
+#include "../segment.h"
+#include "../tcp_type.h"
+
+/** Verify that two segments have the same content */
+void test_seg_same(tcp_segment_t *a, tcp_segment_t *b)
+{
+	PCUT_ASSERT_INT_EQUALS(a->ctrl, b->ctrl);
+	PCUT_ASSERT_INT_EQUALS(a->seq, b->seq);
+	PCUT_ASSERT_INT_EQUALS(a->ack, b->ack);
+	PCUT_ASSERT_INT_EQUALS(a->len, b->len);
+	PCUT_ASSERT_INT_EQUALS(a->wnd, b->wnd);
+	PCUT_ASSERT_INT_EQUALS(a->up, b->up);
+	PCUT_ASSERT_INT_EQUALS(tcp_segment_text_size(a),
+	    tcp_segment_text_size(b));
+	if (tcp_segment_text_size(a) != 0)
+		PCUT_ASSERT_NOT_NULL(a->data);
+	if (tcp_segment_text_size(b) != 0)
+		PCUT_ASSERT_NOT_NULL(b->data);
+	if (tcp_segment_text_size(a) != 0) {
+		PCUT_ASSERT_INT_EQUALS(0, memcmp(a->data, b->data,
+		    tcp_segment_text_size(a)));
+	}
+}
+
+PCUT_INIT
+
+PCUT_IMPORT(conn);
+PCUT_IMPORT(iqueue);
+PCUT_IMPORT(pdu);
+PCUT_IMPORT(rqueue);
+PCUT_IMPORT(segment);
+PCUT_IMPORT(seq_no);
+PCUT_IMPORT(tqueue);
+PCUT_IMPORT(ucall);
+
+PCUT_MAIN()
